package com.aliyun.tablestore.grid.model.grid;

import org.checkerframework.checker.units.qual.A;
import ucar.ma2.DataType;
import ucar.ma2.Index;

import java.nio.ByteBuffer;
import java.util.Arrays;

public class Grid4D extends Grid {

    public Grid4D(ByteBuffer data, DataType dataType, int[] origin, int[] shape) {
        super(data, dataType, origin, shape);
        if (origin.length != 4 || shape.length != 4) {
            throw new IllegalArgumentException("the length of origin and shape must be 2");
        }
    }

    public Grid3D getGrid3D(int idx) {
        if (idx < 0 || idx >= shape[0]) {
            throw new IllegalArgumentException("index out of range");
        }
        int itemSize = shape[1] * shape[2] * shape[3] * dataType.getSize();
        int pos = idx * itemSize;
        ByteBuffer newBuffer = buffer.slice();
        newBuffer.position(pos);
        newBuffer.limit(pos + itemSize);
        newBuffer = newBuffer.slice();
        return new Grid3D(newBuffer, dataType, Arrays.copyOfRange(origin, 1, origin.length),
                Arrays.copyOfRange(shape, 1, shape.length));
    }

    public float[][][][] section(int[] origin, int[] shape) {
    //     // calculate rank
    //     int rank = 0;
    //     for (int size : shape) {
    //         if (size > 1) {
    //             rank++;
    //         }
    //     }
    //     buffer.getShort()
    //     switch (rank) {
    //         case 4: {
    //             float[][][][] result = new float[shape[0]][shape[1]][shape[2]][shape[3]];
    //             Index index = Index.factory(shape);
    //             index.currentElement();
    //             for (int i = 0; i < shape[0]; i++)
    //                 float[][][] grid3D = getGrid3D(i).section(Arrays.copyOfRange(origin, 1, origin.length),
    //                         Arrays.copyOfRange(shape, 1, shape.length));
    //                 for (int j = 0; j < shape[1]; j++)
    //             break;
    //         }
    //         default:
    //             break;
    //     }
    //     // calculate stride
    //     int[] stride = new int[4];
    //     stride[3] = 1;
    //     for (int i = 2; i >= 0; i--) {
    //         stride[i] = stride[i + 1] * shape[i + 1];
    //     }
        return null;
    }
}
