package com.htfp.weather.griddata.utils;

import com.htfp.weather.utils.DateTimeUtils;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import ucar.nc2.NetcdfFile;
import ucar.nc2.NetcdfFiles;

import java.io.IOException;

import static org.junit.jupiter.api.Assertions.*;

/**
 * @Author : shiyi
 * @Date : 2024/3/4 10:21
 * @Description :
 */
class GfsUtilsTest {

    @Test
    void getRefTime() throws IOException {
        String filename = "D:\\HTFP\\weather\\GFSData\\UTC-20240607.00\\BJT-20240607.17-from-UTC-20240607.00+9.grib2";
        NetcdfFile ncFile = NetcdfFiles.open(filename);
        String refTime = GfsUtils.getRefTime(ncFile);
        String s = filename.split("\\+")[1];
        Integer.parseInt(s.split(".grib2")[0]);
        // assertEquals("2023-09-05T00:00+00:00", refTime);
        // Assertions.assertEquals("2023-09-05T08:00+08:00", DateTimeUtils.getBJTDateTimeStringFromUTC(refTime, CoordinateUtils.DATE_TIME_PATTERN));
    }
}